RPL

************************************************
***         Decompression Code               ***
************************************************
***             ULZ v0.4a                    ***
***          by Yann Collet                  ***
************************************************

ASSEMBLE
HEADER EQU #D20
RPL


CODEM
  ST=0.10                 % MemFlag=0
*.ULZretry
  SAVE                    % Save B.A, D.A, D0 & D1; modify C
  C=DAT1.A                % SourceString Address
  RSTK=C                  % Save SourceString Address => RSTK
  CD1EX                   % D1 : SourceString Address
  RSTK=C                  % Save Stack.level.one Address => RSTK
  A=DAT1.A LC(5)DOCSTR
  ?A=C.A { LOADRPL }      % Level1.Object is a string -> go on
  D1+10 A=DAT1.A LC(3)HEADER
  ?A=C.X { LOADRPL }      % Header is ok -> go on

*.CorrectHeader
  D1+3 C=DAT1.A           % C=TargetObject.Size
  GOSBVL =CREATETEMP      % Allocates C.A nibbles; carry if not enough memory
                          % -> D0=bottom, D1=top of area
                          % -> B.A = C.A = @D1 = offset to previous tempob = #nibbles+6
  SKIPNC {
% Explicit Garbage Collection
    ?ST=1.10 -> .MemError
    GOSUB .PassGC
    $(5) =DOCOL           % using SysRPL
    $(5) =GARBAGE         % Garbage Collector Call
    $(5) =COLA
    $(5) =DOCODE          % Starting ASM code again
    G5 .ULZend
    ST=1.10               % MemFlag=1
    GOTO .ULZretry        % Restart Decode
*.PassGC
    C=RSTK                % Get Address of DOCOL
    A=C.A LOAD PC=(A)     % Restore RPL & Start DOCOL
*.MemError
    GOVLNG =GPMEMERR
  }

  C=RSTK CD1EX            % D1 = RSTK = Stack.Level.one
  D=C.A                   % D = End.of.TargetObject
  AD0EX                   % A = Start.of.TempOb (Result Object)
  DAT1=A.A                % Level.one address changed to TempOb (Result Object)
  D1=A                    % D1 = Start.of.TempOb (Result Object)

  C=RSTK D0=C             % Restore D0 = SourceString
  D0+10                   % Skip Prolog & SourceSize
  D0+8                    % Skip Header (IdCode & TargetSize)
  B=0.A
  GOTO .Literals          % Always start with a Descriptor

*.Finalize
		P=0
		?C>D.A -> .CriticalError
  LOADRPL

*.CriticalError           % Writing outside of TempOb -> Critical Error !! (overflow)
		LC(5) =ofloerr
		GOVLNG =GPErrjmpC


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% D0 : Source String pointer
% D1 : Target Object pointer
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

*.DecompLoop
{ ?C>=D.A -> .Finalize    % Test D1 to EOF / 8 (11-18)
  C=RSTK D0=C             % Restore D0 CString  / 8 8

*.Literals
  { C=DAT0.1 D0+1         % Descriptor  / 18 7
  C-1.P GOC .RepeatSequence  % 4 (3-10)
  P=C.0                   % 6
  A=DAT0.WP DAT1=A.WP     % Copy Sequence / (32) (31) 2
  CD0EX C+P+1 CD0EX       % Update D0 (source) / 8 8 8
  CD1EX C+P+1 D1=C        % Update D1 (result) / 8 8 8
		?C>=D.A -> .Finalize    % Premature end if C=D1=EOF / (11-18)
  P+1 P+1 UPC }           % If Descriptor=#F ==> NextDescriptor / 3 3 (3-10)
		P=0                     % / 2

*.RepeatSequence
  A=0.A A=DAT0.3          % Offset / 7 20
  B=A.P                   % First MatchLengthCode / 4
  A+A.A                   % Offset on A.1 / 7
  D0+3                    % Lecture de 3 nibbles / 7

  LC(3)7 B&C.X ?B=C.P     % / 5 7 (7-14)
  ->{ B+1.X C=DAT0.1 B+C.X  % / 6 18 6
    D0+1                  % /
    C+1.P UPC }           % / 3 (3-10)
  B+4.X                   % MatchLength (+MINMATCH) / 6

  CD0EX RSTK=C            % Save D0 / 8 8
  ASR.A A+1.X             % Offset on A.A / 8 6
  CD1EX D1=C C-A.A D0=C   % D1 = Destination(current) ; D0 = source / 8 8 7 8
  A-B.X GOC .CopyOverlap  % If Offset < MatchLength then overlap copy / 6 (3-10)

*.CopySequence
  C=B.A GOSBVL =MOVEDOWN  % Copy downwards C.A nibbles from D0 to D1 / 7 (C=4->9C / C=5->9D / C=6->A0)
  UP                      % Note : C=D1 / 11
*.CopyOverlap
		A+B.X A=0.P ?A#0.X -> .CopySequence
  B-1.X                   % / 6
  { C=DAT0.B DAT1=C.1     % / 15 17
  D1+1 D0+1 B-1.X UPNC }  % Copy nibbles one by one (for overlapping sequences) / 6 7 6 (3-10)
		CD1EX D1=C              % C=D1
		UP                      % Always Carry / 10
}

*.ULZend
ENDCODE

